# coding: utf-8

"""
    Web Forms API version 1.1

    The Web Forms API facilitates generating semantic HTML forms around everyday contracts.   # noqa: E501

    OpenAPI spec version: 1.1.0
    Contact: devcenter@docusign.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from docusign_webforms.client.configuration import Configuration


class WebFormComponent(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'component_key': 'str',
        'component_type': 'str',
        'component_name': 'str'
    }

    attribute_map = {
        'component_key': 'componentKey',
        'component_type': 'componentType',
        'component_name': 'componentName'
    }

    def __init__(self, _configuration=None, **kwargs):  # noqa: E501
        """WebFormComponent - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._component_key = None
        self._component_type = None
        self._component_name = None
        self.discriminator = None

        setattr(self, "_{}".format('component_key'), kwargs.get('component_key', None))
        setattr(self, "_{}".format('component_type'), kwargs.get('component_type', None))
        setattr(self, "_{}".format('component_name'), kwargs.get('component_name', None))

    @property
    def component_key(self):
        """Gets the component_key of this WebFormComponent.  # noqa: E501


        :return: The component_key of this WebFormComponent.  # noqa: E501
        :rtype: str
        """
        return self._component_key

    @component_key.setter
    def component_key(self, component_key):
        """Sets the component_key of this WebFormComponent.


        :param component_key: The component_key of this WebFormComponent.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and component_key is None:
            raise ValueError("Invalid value for `component_key`, must not be `None`")  # noqa: E501

        self._component_key = component_key

    @property
    def component_type(self):
        """Gets the component_type of this WebFormComponent.  # noqa: E501

        The type of component this object represents  # noqa: E501

        :return: The component_type of this WebFormComponent.  # noqa: E501
        :rtype: str
        """
        return self._component_type

    @component_type.setter
    def component_type(self, component_type):
        """Sets the component_type of this WebFormComponent.

        The type of component this object represents  # noqa: E501

        :param component_type: The component_type of this WebFormComponent.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and component_type is None:
            raise ValueError("Invalid value for `component_type`, must not be `None`")  # noqa: E501
        if (self._configuration.client_side_validation and
                component_type is not None and len(component_type) > 100):
            raise ValueError("Invalid value for `component_type`, length must be less than or equal to `100`")  # noqa: E501

        self._component_type = component_type

    @property
    def component_name(self):
        """Gets the component_name of this WebFormComponent.  # noqa: E501

        Name value that is used for mapping components to external sources  # noqa: E501

        :return: The component_name of this WebFormComponent.  # noqa: E501
        :rtype: str
        """
        return self._component_name

    @component_name.setter
    def component_name(self, component_name):
        """Sets the component_name of this WebFormComponent.

        Name value that is used for mapping components to external sources  # noqa: E501

        :param component_name: The component_name of this WebFormComponent.  # noqa: E501
        :type: str
        """
        if (self._configuration.client_side_validation and
                component_name is not None and len(component_name) > 100):
            raise ValueError("Invalid value for `component_name`, length must be less than or equal to `100`")  # noqa: E501

        self._component_name = component_name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(WebFormComponent, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, WebFormComponent):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, WebFormComponent):
            return True

        return self.to_dict() != other.to_dict()
